<template>
    <div id="app">
        <!--    <div id="nav">-->
        <!--      <router-link to="/">Home</router-link> |-->
        <!--      <router-link to="/about">About</router-link>-->
        <!--    </div>-->
        <Navbar id="nav"></Navbar>
        <b-container id="mainContent">
            <ChartView ref="chartView"></ChartView>
            <ChartForm @formFinished="sendData"></ChartForm>
        </b-container>
    </div>
</template>

<style>
#app {
    font-family: Avenir, Helvetica, Arial, sans-serif;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    color: #2c3e50;
}

#mainContent {
    margin-top: 30px;
}
</style>
<script>
    import Navbar from "./components/Navbar";
    import ChartForm from "./components/ChartForm";
    import ChartView from "./components/ChartView";
    import axios from 'axios';

    export default {
        components: {ChartView, ChartForm, Navbar},
        methods: {
            sendData(form) {
                this.$refs.chartView.state = "hidden";
                axios.post('http://' + this.$root.altairServer + '/chart',
                    {
                        data: form,
                        responseType: 'json',
                    })
                    .then(
                        value => {
                            console.debug(value);
                            if (value.data.status === 'success')
                            {
                                if (value.data.format === 'png')
                                {
                                    this.$refs.chartView.displayChartFromPNGBase64(value.data);
                                }
                                else if (value.data.format === 'svg')
                                {
                                    this.$refs.chartView.displayChartFromSVG(value.data);
                                }
                                else if (value.data.format === 'html')
                                {
                                    this.$refs.chartView.displayChartFromHTML(value.data);
                                }
                                else
                                {
                                    this.$refs.chartView.state = "hidden";
                                }
                            }
                            else if(value.data.status === 'error')
                            {
                                this.$refs.chartView.state = 'error';
                                this.$refs.chartView.error.message = value.data.message;
                            }
                        })
                    .catch((error) => {
                        if (error.response) {
                            // Request made and server responded
                            console.log(error.response.data);
                            console.log(error.response.status);
                            console.log(error.response.headers);
                        } else if (error.request) {
                            // The request was made but no response was received
                            console.log(error.request);
                        } else {
                            // Something happened in setting up the request that triggered an Error
                            console.log('Error', error.message);
                        }

                    });
                this.$refs.chartView.state = "loading";
            }
        }
    }
</script>